from paddlex_hps_server import BaseTritonPythonModel, schemas, utils


class TritonPythonModel(BaseTritonPythonModel):
    def get_input_model_type(self):
        return schemas.ts_anomaly_detection.InferRequest

    def get_result_model_type(self):
        return schemas.ts_anomaly_detection.InferResult

    def run(self, input, log_id):
        file_bytes = utils.get_raw_bytes(input.csv)
        df = utils.csv_bytes_to_data_frame(file_bytes)

        result = list(self._pipeline.predict(df))[0]

        output_csv = utils.base64_encode(utils.data_frame_to_bytes(result["anomaly"]))
        return schemas.ts_anomaly_detection.InferResult(csv=output_csv)
